package com.fzm.portal;

import cn.fzm.chain.simplesdk.client.ParaChainClient;
import cn.hutool.json.JSONUtil;
import com.fzm.common.constant.RedisConstant;
import com.fzm.common.entity.CopyrightAuthorityRelation;
import com.fzm.common.entity.OpusCategory;
import com.fzm.common.entity.dto.CopyrightRequest;
import com.fzm.common.entity.vo.CopyrightVo;
import com.fzm.common.enums.ResultCode;
import com.fzm.common.exception.GlobalException;
import com.fzm.common.service.CopyrightApplyService;
import com.fzm.common.service.CopyrightAuthorityRelationService;
import com.fzm.common.service.OpusCategoryService;
import com.fzm.common.service.impl.CopyrightAuthorityRelationServiceImpl;
import com.fzm.common.utils.JsonUtil;
import com.fzm.common.utils.RedisUtil;
import org.junit.jupiter.api.Test;
import org.redisson.Redisson;
import org.redisson.api.RSemaphore;
import org.redisson.api.RedissonClient;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.security.crypto.password.PasswordEncoder;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.concurrent.ExecutionException;

@SpringBootTest
class LyPortalApplicationTests {

    @Resource
    private RedisUtil redisUtil;

    @Resource
    private PasswordEncoder passwordEncoder;

    @Resource
    StringRedisTemplate stringRedisTemplate;

    @Resource
    ParaChainClient paraClient;

    @Resource
    RedissonClient redisson;

    @Resource
    private CopyrightApplyService copyrightApplyService;

    @Resource
    private OpusCategoryService opusCategoryService;

    @Test
    void test1() throws ExecutionException, InterruptedException {
        CopyrightVo detail = copyrightApplyService.getDetail(48);
        OpusCategory opusCategory = opusCategoryService.getById(1);
        CopyrightRequest.CopyrightDetail copyrightDetail = new CopyrightRequest.CopyrightDetail(detail, opusCategory);
//        CopyrightRequest copyrightRequest = new CopyrightRequest(copyrightDetail);
//        System.out.println(JSONUtil.toJsonStr(copyrightRequest));
    }

    @Test
    void contextLoads() {
        System.out.println("redisson = " + redisson);
        RSemaphore semaphore = redisson.getSemaphore("banner09");

        boolean b = semaphore.trySetPermits(10);
        for (int i = 0; i < 3; i++) {
            boolean acquire = semaphore.tryAcquire();
            if (!acquire) {
                throw GlobalException.newException(ResultCode.VALIDATE_FAILED);
            }
            //System.out.println("semaphore.drainPermits() = " + semaphore.drainPermits());
            System.out.println("semaphore.availablePermits() = " + semaphore.availablePermits());
        }

    }

}
